// meta4ra -- Metalink 4.0 utilities
// Copyright (C) 2021-2026 Sergey Matveev <stargrave@stargrave.org>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, version 3 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

package internal

import (
	"crypto/sha3"
	"io"
)

type shake struct {
	h *sha3.SHAKE
	l int
}

func (h shake) Size() int {
	return h.l
}

func (h shake) BlockSize() int {
	return h.h.BlockSize()
}

func (h shake) Reset() {
	h.h.Reset()
}

func (h shake) Write(p []byte) (int, error) {
	return h.h.Write(p)
}

func (h shake) Sum(b []byte) []byte {
	buf := make([]byte, h.l)
	if _, err := io.ReadFull(h.h, buf); err != nil {
		panic(err)
	}
	return append(b, buf...)
}
